#!/bin/tclsh

set FILENAME "/etc/config/addons/presence/trigger.conf"

set hour 0
set minute 0
set delay 0

array set args { command INV hour 0 minute 0 delay 0 }

proc parseQuery { } {
	global args env
	
	set query [array names env]
	if { [info exists env(QUERY_STRING)] } {
		set query $env(QUERY_STRING)
	}
	
	foreach item [split $query &] {
		if { [regexp {([^=]+)=(.+)} $item dummy key value] } {
			set args($key) $value
		}
	}
}


proc loadFile { fileName } {
	set content ""
	set fd -1
	
	set fd [ open $fileName r]
	if { $fd > -1 } {
		set content [read $fd]
		close $fd
	}
	
	return $content
}

proc loadConfigFile { } {
	global FILENAME hour minute delay
	
	array set content {HOUR 0 MINUTE 0 DELAY 0}
	catch { array set content [loadFile $FILENAME] }
	
	set hour $content(HOUR)
	set minute $content(MINUTE)
	set delay $content(DELAY)
}

proc saveConfigFile { } {
	global FILENAME args
	
	array set content {}
	set content(HOUR) $args(hour)
	set content(MINUTE) $args(minute)
	set content(DELAY) $args(delay)
	
	set fd [open $FILENAME w]
	puts $fd [array get content]
	close $fd
}

parseQuery
if { $args(command) == "save" } {
	saveConfigFile
	catch { close [open "|/etc/config/rc.d/presence restart"] }
} 

loadConfigFile


set content [loadFile index.template.html]
regsub -all {<%hour%>} $content $hour content
regsub -all {<%minute%>} $content $minute content
regsub -all {<%delay%>} $content $delay content


puts $content
